
randn('state', 0); rand('state', 0);
varsels = [];
modelErrs = []; estErrs = [];
rankEsts = []; grpnumEsts = [];

times = 20 
numMethods = 0;
for timeInd = 1:times
    disp(['timeInd=', num2str(timeInd)])
    
    if genBOnce == 1 && timeInd == 1        
        B_raw = randn(initD, initR) * randn(initR, initN);
        B_raw = [B_raw; zeros(initP-initD, initN)];
    end    
    
    run geneSRRRData;
    BXsingvalsTH = sqrt(svd(m*B_true' * corrMat * B_true));
    snrTHs = [snrTHs, BXsingvalsTH(initR)/sigma/(sqrt(rank(X)) + sqrt(size(Y,2)))]; %(sqrt(size(Y,1)) + sqrt(size(Y,2)))];
    if timeInd==1 || timeInd==times, disp(['SNR: Smallest nz sing-val of XB/sigma/(sqrt(m)+sqrt(n)): ', num2str( snrTHs(end) )]), end
    
%     tstX = X; tstY = Y;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Method 1: RSC
    preSelDims = [];
    sprintf('...method: RSC')
    if exist('preSelDims', 'var') && ~isempty(preSelDims)
        X0 = X; X = X(:, preSelDims);
        run RSC;    
        X = X0; 
        [m, n] = size(Y); d = size(X, 2); numBs = size(Bs, 3);
        Bs2 = zeros(d, n, numBs);
        for k=1:numBs
                Bs2(preSelDims, :, k) = Bs(:, :, k);
        end
        Bs = Bs2;
    else
        run RSC; 
    end
    RSC_Bs = Bs;  RSC_Rs = tuningparams;
        
    q = rank(X);
    if q ~= sum(svd(X)>1e-4)
        error('wrong rank calculaton')
    end

    sigmasqEsts = trnerr./((m-kopts).*n); %trnerr./((m).*n) % 

    if m > d || (exist('initQ', 'var') && initQ < initM) % The large sample size case
        % We can use the projection to remove the sigmal and so
        % estimate sigma.
        sigmasqEst = norm(Y-X*(pinv(X'*X)*X')*Y, 'fro')^2/((m-q)*n);
    else % Large-p case with X of full row rank 
        % The case is not studied in the RSC paper.
        % I used Weyl's theorem to construct bounds for sigma to make
        % an initial guess of the rank, and then use the corresponding
        % sigma to specify the tuning parameter later.
        sings1 = svd(Y)';
        sings2 = svd(E)';
        u0 = numel(sings1);
        r0 = 1; % u0/2;
        candranks = [];
        while 1 % for ttt = 1:u0/2 %
%                 r0 = ttt;
            while 1
                sigmaEstU = min(sings1(1:(u0-r0))./sings2(r0+1:end));
                sigmaEstL = max(sings1(r0+1:end)./sings2(1:(u0-r0)));
                if sigmaEstL > sigmaEstU
                    % disp('rank too low');
                    r0 = r0 + 1;
                else
                    break;
                end
            end
            disp([sigmaEstL, sigmaEstU])
%                 sigmaEst = (sigmaEstL + sigmaEstU)/2;
            r0rev = find(sigmasqEsts >= sigmaEstL & sigmasqEsts <= sigmaEstU);   
            if isempty(r0rev)
                r0rev = find(sigmasqEsts <= sigmaEstU, 1, 'first');
            else
                r0rev = floor(median(r0rev));
            end
            disp([r0, r0rev])
            candranks = [candranks, [r0; r0rev; sigmaEstL; sigmaEstU]];
            if r0 > u0/2
                break;
            else
                r0 = r0 + 1;
            end
        end                        
        candind = candranks(1,1);
        sigmasqEst = sigmasqEsts(candind);
    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Tuning with sigma known: The theoretically opt mu with sigma known (=1 here)
    theta0 = 0; %1; 
    alpha0 = 1; %0.1353; %  
    lambda_thopt = sqrt(2) * sigma * (sqrt(n + rank(X)) );
    %%sqrt(1+theta0) * sigma * (sqrt(n) + sqrt(rank(X)) + sqrt(-2*(log(alpha0))) );
    %sum(eigDdiag >= lambda_thopt^2);
    %eigDdiag'./lambda_thopt^2;
    ROpt = sum(eigDdiag >= lambda_thopt^2); 
    if ROpt == 0
        BOpt = zeros(size(Bs(:,:,1)));
    else
        optInd = find(kopts == ROpt, 1, 'first');
        BOpt = Bs(:, :, optInd);
    end         
    modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2 ];  % norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1  
    estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
    rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Tuning with sigma unknown: Theoretically opt mu with estimated sigma
    % from above
    if m > d
        lambda_thopt = sqrt(2) * sqrt(1* sigmasqEst)*(sqrt(n + rank(X)) ); %sqrt(2) * sqrt(1* sigmasqEst) * (sqrt(n) + sqrt(rank(X))); %
    else
        lambda_thopt = sqrt(2) * sqrt(1* sigmasqEst)*(sqrt(n + rank(X)) ); %sqrt(2) * sqrt(2* sigmasqEst) * (sqrt(n) + sqrt(rank(X))); %
    end
    ROpt = sum(eigDdiag >= lambda_thopt^2); % tuningparamOpt;
    if ROpt == 0
        BOpt = zeros(size(Bs(:,:,1)));
    else
        optInd = find(kopts == ROpt, 1, 'first');
        BOpt = Bs(:, :, optInd);
    end 
    modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2 ];  % norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1  
    estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
    rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end

         
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     % Method 2: NNP
%     sprintf('...method: NNP')
%     calib = 0;
%     run NNP;
%     NNP_Bs = Bs; 
%     
%     % Try the large-validation-data tuning
%     run valTuning;
% %     BOpt = Bs(:, :, optInd);
%     lambdaOpt = tuningparamOpt;
%     ROpt = kopts(optInd);
%     
%     modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1   
%     estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
%     rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
%     
%     NNP_Lambdas = tuningparams; NNP_ks = kopts; NNP_BOpt = BOpt; NNP_ROpt = ROpt;
%         
%     % Theoretical choice with sigma known
%     lambdaOpt21 = sqrt(2) * sqrt(1)*(sqrt(n + rank(X)) )*max(svd(X));
%     nnpindOpt1 = find(abs(lambdas - lambdaOpt21) == min(abs(lambdas - lambdaOpt21)), 1, 'first');
%     BOpt = NNP_Bs(:, :, nnpindOpt1);
%     ROpt = kopts(nnpindOpt1);
%     modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1   
%     estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
%     rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
%     % Theoretical choice with estimated sigma
%     lambdaOpt22 = sqrt(2) * sqrt(1* sigmasqEst)*(sqrt(n + rank(X)) )*max(svd(X));
%     nnpindOpt2 = find(abs(lambdas - lambdaOpt22) == min(abs(lambdas - lambdaOpt22)), 1, 'first');
%     BOpt = NNP_Bs(:, :, nnpindOpt2);
%     ROpt = kopts(nnpindOpt2);
%     modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1   
%     estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
%     rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
    
%     % Method 2': nnp calibrated
%     sprintf('....method: NNP^c')
% %     ROpt = sum( svd(X * NNP_BOpt) > lambdaOpt*(1+1/min(svd(X))) ); % (4*lambdaOpt/min(svd(X))) ); % (2*lambdaOpt/min(svd(X))) ); % 
% %     if ROpt > 0
% %         BOpt = RSC_Bs(:, :, ROpt);
% %     else
% %         BOpt = zeros(size(RSC_Bs(:,:,1)));
% %     end
%     
%     calib = 1
%     run NNP;
%     run valTuning;
% %     BOpt = Bs(:, :, optInd);
%     lambdaOpt = tuningparamOpt;
%     ROpt = kopts(optInd);
%     
%     modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1
%     estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
%     rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
% %          
% %         % Theoretical choice with sigma known
% %         BOpt = Bs(:, :, nnpindOpt1);
% %         ROpt = kopts(nnpindOpt1);
% %         modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1   
% %         estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
% %         rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
% %         % Theoretical choice with estimated sigma
% %         BOpt = Bs(:, :, nnpindOpt2);
% %         ROpt = kopts(nnpindOpt2);
% %         modelErrs = [modelErrs; norm(tstX*B_true-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2]; %norm(tstY-tstX*BOpt,'fro')^2/numel(tstY)/initSigma^2-1   
% %         estErrs = [estErrs; norm(B_true-BOpt,'fro')^2/numel(B_true)/initSigma^2];
% %         rankEsts = [rankEsts; ROpt]; if timeInd == 1, numMethods = numMethods + 1; end
        

end
rankEstsOrig = rankEsts; modelErrsOrig = modelErrs; estErrsOrig = estErrs; grpnumEstsOrig = grpnumEsts; varselsOrig = varsels;
rankEsts = []; modelErrs = []; estErrs = [];
for tmpInd = 1:numMethods
    rankEsts = [rankEsts, rankEstsOrig(tmpInd:numMethods:end)];
    modelErrs = [modelErrs, modelErrsOrig(tmpInd:numMethods:end)];
    estErrs = [estErrs, estErrsOrig(tmpInd:numMethods:end)];
end

    
disp(['Dataname:', dataName, ',  Summerizing result... (with m: ', num2str(initM), ', d=', num2str(initP), ', J= ', num2str(initD), ', n=', num2str(initN), ', r=', num2str(initR), ', sig-str = ', num2str(initBStrength), ', sigma=', num2str(initSigma), ')' ])
% CentMean([rankEsts], .4, .6)'
100 * CentMean([modelErrs], .4, .6)'
% 100 * mean([modelErrs])'
100 * CentMean([estErrs], .4, .6)'
disp(['median rank val:', num2str(median([rankEsts]))]) %, mean(rankEsts)


% figure; hist(rankEsts); title('Histogram of rank estimates'); legend('RSC', 'NNP', 'NNP^c')
% figure; hist(modelErrs); title('Histogram of SMSE');  legend('RSC', 'NNP', 'NNP^c')

