% This script runs simulation experiments to show the performance of RSC
% with the theoretical tuning of the regularization parameter, and the
% tuning based on a sigma estimate, written and maintained by Y. She. 

clear; clc;
summRes_rank = []; summRes_rankrec = [];
summRes_SMSE = []; summRes_EstErr = [];
lambdaQuans = []; snrTHs = [];

%% A large-n setting: 
initM = 100 %50 % 
valM = 10000; tstM = 10000;
initD = 15 %10 % 25 %100 % 10; %5 %    
initP = 25 % 100 % 
initN = 25 %10; %5 %   
initR = 5 %3 %8 %10 %  
initSigma =  1; % 3 %
genBOnce = 1;
initBStrengthVec = [0.2, 0.4] %; 1 % [0.1 0.2 0.3 0.4 ]; % [0.05 0.1 0.2 0.3 0.4 ];

% %% A large-p setting:
% initM = 30 %50 %    
% valM = 10000; tstM = 10000;
% initD = 15; %5 %15 % 100 %200 %   
% initP = 100
% initN = 10 %5 %10; %25 %    
% initR = 2 %5 %10 %  
% initSigma =  1; % 3 %
% genBOnce = 1;
% initBStrengthVec = [0.5, 1]; %  [0.1 0.2 0.3 0.4 ]; %[0.025 0.05 0.1 0.2 0.3 0.4 ]; %[0.3 0.4]; %[0.025 0.05 0.1 0.2]; 
% % initQ = initM/2;

dataName = 'mynorm-mildcorr' %'mynorm-medcorr' %'mynorm-iid' %'mynorm-highcorr' %   

for bInd = 1:numel(initBStrengthVec)
    initBStrength = initBStrengthVec(bInd);
    run Main_aux;
    summRes_rank = [summRes_rank, median([rankEsts])']; % CentMean([rankEsts], .4, .6)'
    summRes_rankrec= [summRes_rankrec, mean(rankEsts==initR)'*100 ];
    summRes_EstErr = [summRes_EstErr, 1 * CentMean([estErrs], .4, .6)'];
    summRes_SMSE = [summRes_SMSE, 1 * CentMean([modelErrs], .4, .6)']; 
end
snrTHs = snrTHs(1:times:end)
disp('Pred err'), 100*(summRes_SMSE')
disp('Est err'), 100*(summRes_EstErr')
disp('Rank est'), (summRes_rank')
disp('Rank recovery rate'), (summRes_rankrec')

% The first is based on the theoretical choice of the regularizaiton parameter assuming sigma known, and
% the second is the same except that sigma is unknown. 