function X_th = MatSingTh_mat(X, lambda, thresholdingWay, nu)
if ~exist('Nu', 'var')
    nu = 0;
end

if ~exist('thresholdingWay', 'var')
    thresholdingWay = 'hard';
end

[U,S,V] = svd(X, 'econ');
xi_new_diag = diag(S);
% disp(xi_new_diag');
gamma_E_diag = zeros(size(xi_new_diag)); 
switch lower(thresholdingWay)
    case {'soft'}    
        ttInds = find(xi_new_diag>lambda);
        gamma_E_diag(ttInds) = xi_new_diag(ttInds) - lambda; 
    case {'hard'}
        ttInds = find(xi_new_diag>lambda);
        gamma_E_diag(ttInds) = xi_new_diag(ttInds);   
    case {'ridge'}
        gamma_E_diag  = xi_new_diag ./(1+lambda);   % there's a singe paramter. we still call it lambda
    case {'hybrid'}
        ttInds = find(xi_new_diag>lambda);
        gamma_E_diag(ttInds) = xi_new_diag(ttInds) ./ ( 1+nu);   
    case {'hard-number'}      % lambda here is the number of nz components to keep
        [st, ix] = sort(xi_new_diag, 'descend');
        ttInds = ix(1:lambda);
        gamma_E_diag(ttInds) = xi_new_diag(ttInds);
    case{'hybrid-number'}
        [st, ix] = sort(xi_new_diag, 'descend');
        ttInds = ix(1:lambda);
        gamma_E_diag(ttInds) = xi_new_diag(ttInds) ./ ( 1+nu);;
            
end

X_th = U * diag(gamma_E_diag) * V';
