function[BEst, sing, totNum] = TISP_RRR(X, Y, Lambda, thresholdingWay, errBnd, maxIT, BInit, Nu, updating, relaxWay);   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X has been scaled

T = eye(size(X, 2));
%initWay ??
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%% Initionaliztion starts %%%%%%%%%%%%%%%%%%%%
if ~exist('updating', 'var')  | isempty(updating)
    updating = 'synchronous' % 'asynchronous' % 'coordes' %
end

[m, d] = size(X); 
n = size(Y, 2);
if n > d, error('Always assume d>n (num of cols of X > num of cols of Y)!'), end

if isempty(BInit)
    BInit = zeros(d, n); % glmfit(X, y, 'binomial', 'constant', 'off') %  
else
    BInit = reshape(BInit, d, n);
end
B_cur =  BInit;

if numel(Lambda) == 1
    Lambda_new = Lambda * ones(n, 1);
else
    Lambda_new = reshape(Lambda, n, 1);
end

if exist('Nu', 'var')  && ~isempty(Nu)  
    if max(Nu)>.1 && ~strcmp(thresholdingWay, 'hybrid') && ~strcmp(thresholdingWay, 'hybrid-prop')
        % if not hybrid, 0 or a very small value which helps decorrelation
        error('Nu should be close to 0')
    end
    if numel(Nu) == 1
        Nu_new = Nu * ones(n, 1);
    else
        Nu_new = reshape(Nu, n, 1);
    end
else
    if strcmp(thresholdingWay, 'hybrid') || strcmp(thresholdingWay, 'hybrid-prop')
        sprintf('Nu not specified; set to be lambda/4')
        Nu_new = (Lambda_new)/4;% for snr low or medium, not huge; good init
    else
        Nu_new = [];
    end    
end

if ~exist('relaxWay', 'var')
    relaxWay = 0;
end
if relaxWay == 1
    omega = 2;
    xi_cur = zeros(d, n); 
else
    omega = 1;
end

j = 0; 
matXY = X' * Y;
realInnErrBnd = errBnd;
gamma_E = zeros(size(B_cur));
gamma_E_diag = diag(gamma_E);

% recorrIT = 50; %maxIT + 1; % 
%%%%%%%%%%% ITERATION starts %%%%%%%%%%%%%%%%%%%%
while 1
    j = j + 1;

    switch lower(updating)
    case {'synchronous'}
        mu = X * B_cur; %exp(X * beta_cur) ./ (exp(X * beta_cur) + 1);      
        xi_new =  B_cur + matXY - X' * mu;
        if j > 1 && relaxWay == 1
            xi_new = (1 - omega) * xi_cur + omega * xi_new; 
        end
       
        [U,S,V] = svd(xi_new, 'econ');
        xi_new_diag = diag(S);

                
        % thresholding
        switch lower(thresholdingWay)
            case {'soft'}    
                gamma_E_diag(:) = 0; 
                gamma_E_diag(xi_new_diag>Lambda_new) =  xi_new_diag(xi_new_diag>Lambda_new) - Lambda_new(xi_new_diag>Lambda_new); 
                gamma_E_diag(xi_new_diag<-Lambda_new) = xi_new_diag(xi_new_diag<-Lambda_new) + Lambda_new(xi_new_diag<-Lambda_new);  
            case {'hard'}
                gamma_E_diag(:) = 0; 
        %             gamma_E_diag(xi_new_diag>Lambda_new) =  xi_new_diag(xi_new_diag>Lambda_new);  % hard
        %             gamma_E_diag(xi_new_diag<-Lambda_new) = xi_new_diag(xi_new_diag<-Lambda_new);
                gamma_E_diag(abs(xi_new_diag)>Lambda_new) = xi_new_diag(abs(xi_new_diag)>Lambda_new);            
            case {'none'}
                gamma_E_diag = xi_new_diag; % no thresholding -- takes more iterations
            case {'scad'}
                a = 3.7;
                gamma_E_diag(:) = 0; 
                gamma_E_diag(xi_new_diag>Lambda_new) =  xi_new_diag(xi_new_diag>Lambda_new) - Lambda_new(xi_new_diag>Lambda_new); 
                gamma_E_diag(xi_new_diag<-Lambda_new) = xi_new_diag(xi_new_diag<-Lambda_new) + Lambda_new(xi_new_diag<-Lambda_new);              

                gamma_E_diag(xi_new_diag>2*Lambda_new) =  ( (a-1)*xi_new_diag(xi_new_diag>2*Lambda_new) - a * Lambda_new(xi_new_diag>2*Lambda_new) ) / (a-2); 
                gamma_E_diag(xi_new_diag<-2*Lambda_new) =  ( (a-1)*xi_new_diag(xi_new_diag<-2*Lambda_new) + a * Lambda_new(xi_new_diag<-2*Lambda_new) ) / (a-2);             

        %             gamma_E_diag(xi_new_diag>a * Lambda_new) =  xi_new_diag(xi_new_diag> a * Lambda_new);  % hard
        %             gamma_E_diag(xi_new_diag<-a * Lambda_new) = xi_new_diag(xi_new_diag<-a * Lambda_new);
                gamma_E_diag(abs(xi_new_diag)>a*Lambda_new) = xi_new_diag(abs(xi_new_diag)>a*Lambda_new);  
            case {'hybrid'}
                gamma_E_diag(:) = 0; 
                gamma_E_diag(abs(xi_new_diag)>Lambda_new) =  xi_new_diag(abs(xi_new_diag)>Lambda_new) ./ ( 1+Nu_new(abs(xi_new_diag)>Lambda_new));                         
            case {'hybrid-prop'}

                    quan = 1 - Lambda / d;
                    quan(quan < 0) =0; 
                    thval = quantile(abs(xi_new_diag), quan); % Lambda of the components of beta are nonzeros                    
                    thval(quan==0) = 0;

                    % due to the implementation of quantile, thval(1) is not zero even if Lambda(1) = 0
                gamma_E_diag(:) = 0;
                gamma_E_diag(abs(xi_new_diag) > thval) = xi_new_diag(abs(xi_new_diag) > thval) ./ ( 1+Nu_new(abs(xi_new_diag)>thval));
            case {'ridge'}
                gamma_E_diag =  xi_new_diag ./ (1+Lambda_new); 
            otherwise
                error('not implemented yet')
        end  
    case {'asynchronous'}  
        ;
    case {'coordes'}
        ;
    otherwise
        error('wrong updating parameter')
    end
    gamma_E = U * diag(gamma_E_diag) * V';
    B_new = gamma_E;

    if  (max(abs(B_new-B_cur)) < realInnErrBnd ) % &&mod(j, recorrIT) > recorrIT/10
        break;
    end
    if j >= maxIT % 1e+6 %1e+5 %
        sprintf('maxIT reached!!')
        switch lower(thresholdingWay)
            case {'hard', 'hybrid', 'hybrid-prop'}
                warning(['not implemented yet for maxIT final correction'])
%            case {'hybrid'} % same as 'hard' because of the existence of Nu
%                if strcmp(intercptchoice, 'none') | strcmp(intercptchoice, 'fixedopt')
%                     % note: no scaling for this function
%                     B_new(B_new~=0) = GLM_opt(X(:, B_new~=0), y, Nu, family, alpha);
%                         %logRegFun(y, X(:, B_new~=0), Nu); % only for logistic!
%                         %GLM_cvxopt(X(:, B_new~=0), y, family, 'l2', Nu);
%                         %TISP_GLM(X(:, B_new~=0), y, Nu, family, 'ridge', errBnd, maxIT, B_new( B_new~=0));
%                             % may use another way to get the partial l2-logistic solution!
%                elseif strcmp(intercptchoice, 'simuopt')
%                     tmpw = GLM_opt([ones(m, 1), X(:, B_new~=0)], y, [0; Nu*ones(sum(B_new~=0),1)], family); % no penalty for intercept
%                     B_new(B_new~=0) = tmpw(2:end); 
%                     alpha = tmpw(1)*ones(m,1);
%                elseif strcmp(intercptchoice, 'simuopt2')
%                    B_new(B_new~=0) = GLM_opt(X(:, B_new~=0), y, [0; Nu*ones(sum(B_new~=0)-1,1)], family, alpha); % alpha might be nz for 'fixedopt'
%                end

            otherwise
            	warning([thresholdingWay, ': not implemented yet for maxIT final correction'])
        end                  
        break;
    end
    
    B_cur = B_new;
    if relaxWay == 1 
        xi_cur = xi_new; % relaxation
    end
    
%     j, B_cur
end

BEst = B_new;
totNum = j;
sing = gamma_E_diag;

% % if ~strcmp(updating, 'asynchronous') | strcmp(oldupdating, 'synchronous') % d>1
% sprintf([num2str(updating) , ' | Lambda, j: ', num2str(Lambda(end)), ', ', num2str(j), '; num of nz: ', num2str(sum(BEst~=0))]) %
% % end